﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using System.Diagnostics;
using System.Collections;
using Infragistics.Web.UI;
using System.Text;

public partial class _Default : System.Web.UI.Page
{
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        this.InitialisePage(!Page.IsPostBack);
    }

    public void InitialisePage(bool refresh)
    {
        if (refresh)
        {
            //MPE.dOOdads.PayloadData.Clients clients = new MPE.dOOdads.PayloadData.Clients(HttpContext.Current.Server.MachineName, Common.Tools.GetApplicationDataBase());

            //clients.LoadAll();

            //this.grdClients.DataSource = clients.DefaultView.Table;
            this.grdClients.DataSource = this.GetGridData("data");
            this.grdClients.DataBind();

            //this.ViewState.Add("grdClients.DataSource", clients.DefaultView.Table);
            this.ViewState.Add("grdClients.DataSource", grdClients.DataSource);
        }
        else
        {
            // Since there isn't a way to update the ViewState of the page when an AJAX request is made for updating the rows
            // the data shouldn't be stored in the ViewState of the page.  This is why Session is used instead.
            //this.grdClients.DataSource =this.ViewState["grdClients.DataSource"];
            this.grdClients.DataSource = this.GetGridData("data"); 
        }
    }

    protected void grdClients_ItemCommand(object sender, Infragistics.Web.UI.GridControls.HandleCommandEventArgs e)
    {
        try
        {
            //MPE.dOOdads.PayloadData.Clients clients = new MPE.dOOdads.PayloadData.Clients(HttpContext.Current.Server.MachineName, Common.Tools.GetApplicationDataBase());
            
            //clients.LoadByPrimaryKey(int.Parse(e.CommandArgument.ToString()));
            //clients.DeleteAll();
            //clients.Save();
            DataTable dt = this.grdClients.DataSource as DataTable;
            DataRow dr = dt.Rows.Find(int.Parse(e.CommandArgument.ToString())) as DataRow;
            dr.Delete();
            dt.AcceptChanges();
            // call ClearDataSource after removing the row from the datasource.
            grdClients.ClearDataSource();
            this.InitialisePage(true);
        }
        catch
        {
            //MPE.Common.Tools.MessageBox(this.Page, "Client is in use and cannot be deleted.");
            System.Diagnostics.Debug.WriteLine("Exception Caught in grdClients_ItemCommand");
        }
    }

    protected void grdClients_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        //MPE.dOOdads.PayloadData.Clients clients = new MPE.dOOdads.PayloadData.Clients(HttpContext.Current.Server.MachineName, Common.Tools.GetApplicationDataBase());
        //clients.AddNew();

        //clients.UserClientId = Common.Session.GetUserAccount().ClientId;
        //clients.ClientName = e.Values["ClientName"].ToString();
        //clients.Save();

        this.InitialisePage(true);
    }

    protected void grdClients_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        //MPE.dOOdads.PayloadData.Clients clients = new MPE.dOOdads.PayloadData.Clients(HttpContext.Current.Server.MachineName, Common.Tools.GetApplicationDataBase());

        //clients.LoadByPrimaryKey((int)((object[])e.RowID["key"])[0]);
        //clients.ClientName = e.Values["ClientName"].ToString();
        //clients.Save();        
        //DataTable dt = this.GetGridData("data");
        DataTable dt = this.grdClients.DataSource as DataTable;
        GridRecord gr = grdClients.Rows.FromIDPair(e.RowID);
        DataRow dr = dt.Rows.Find(gr.DataKey) as DataRow;
        if (dr != null)
        {
            dr["ClientName"] = e.Values["ClientName"].ToString();
        }
        dt.AcceptChanges();
        this.grdClients.ClearDataSource();
        this.InitialisePage(true);
    }


    private DataTable GetGridData(string dataStore)
    {
        return this.GetGridData(dataStore, 10);
    }

    private DataTable GetGridData(string dataStore, int rows)
    {
        DataTable dtData = Session[dataStore] as DataTable;
        if (dtData == null)
        {
            dtData = new DataTable("TestData");

            DataColumn col = dtData.Columns.Add("ClientId", typeof(int));
            dtData.Columns.Add("ClientName", typeof(string));
            dtData.Columns.Add("Col_2", typeof(string));
            dtData.Columns.Add("Col_3", typeof(int));
            dtData.Columns.Add("Col_4", typeof(bool));
            dtData.PrimaryKey = new DataColumn[] { col };
            for (int i = 1; i <= rows; i++)
            {
                DataRow dr = dtData.NewRow();
                dr["ClientId"] = i;
                dr["ClientName"] = "Col 1 Row " + i.ToString();
                dr["Col_2"] = "Col 2 Row " + i.ToString();
                dr["Col_3"] = (i % 2 == 0) ? -i : i;
                dr["Col_4"] = false;
                //dr["Col_4"] = (i % 2 == 0);

                dtData.Rows.Add(dr);
            }
            Session[dataStore] = dtData;
        }

        return dtData;
    }


}
